#include <avsys.h>
#include <gfx.c>

/*
  ILY
	
  Written by Bill Baxter for his Wife

*/

#define SPR_ILY SPRITE(0,0)
#define SPR_HEART SPRITE(0,16)
#define SPR_ILY_W 64
#define SPR_ILY_H 16
#define SPR_HEART_W 16
#define SPR_HEART_H 13
#define MAX_X (LCD_WIDTH - 2*SPR_HEART_W - SPR_ILY_W)

int g_x = 0;
int g_y = 0;
int g_dx = 3;
int g_dy = 3;
    
int main_loop()
{
	unsigned char penx,peny;
	int key;

	while(-1)
	{
            key=GetKey(&penx,&peny);
            if(key==PGDN)
            {
                key=0;
            }
            if(key==PGUP)
            {
                key=0;
            }
            if(key&&key!=255)
            {
                return key;
            }
            if(key&&key==255)
            {
                return APPLICATION;
            }
        }
}

int main()
{
    int x;
    unsigned char penx, peny;

    while (1) {
        SetToVirtualLCD(0);
        ClearLCD(0);
        SetToRealLCD(0);

        g_x += g_dx;
        g_y += g_dy;
        if (g_x < 0) {
            g_x = -g_x;
            g_dx = -g_dx;
            Buzzer(1, 1);
        }
        else if (g_x > MAX_X) {
            g_x = MAX_X;
            g_dx = -g_dx;
            Buzzer(3, 1);
        }
        if (g_y < 0) {
            g_y = -g_y;
            g_dy = -g_dy;
            Buzzer(5, 1);
        }
        else if (g_y > (LCD_HEIGHT - SPR_HEART_H)) {
            g_y = (LCD_HEIGHT - SPR_HEART_H);
            g_dy = -g_dy;
            Buzzer(7, 1);
        }
        x = g_x;
        gfx_blit(x, g_y, SPR_HEART_W>>3, SPR_HEART_H, SPR_HEART, GFX_BLIT_OR);
        x += SPR_HEART_W;
        gfx_blit(x, g_y, SPR_ILY_W>>3, SPR_ILY_H, SPR_ILY, GFX_BLIT_OR);
        x += SPR_ILY_W;
        gfx_blit(x, g_y, SPR_HEART_W>>3, SPR_HEART_H, SPR_HEART, GFX_BLIT_OR);

	LCDCopy(VIRTTOREAL);
        if(GetKey(&penx, &peny)) {
            PenBeep();
            break;
        }
	Delay_10ms();
	Delay_10ms();
	Delay_10ms();
	Delay_10ms();
    }
}

